//
// Created by nicol on 2018-03-25.
//

#ifndef EVENSTORE_CLIENT_C_SUBSCRIPTION_H
#define EVENSTORE_CLIENT_C_SUBSCRIPTION_H

#include "utils/bool.h"
#include "utils/error.h"
#include "utils/uuid.h"
#include "tcp_package.h"

typedef struct st_esc_connection esc_connection_t;
typedef struct st_esc_resolved_event esc_resolved_event_t;
typedef struct st_esc_credentials esc_credentials_t;

typedef struct st_esc_subscription esc_subscription_t;

typedef void (*esc_event_appeared_t)(void* ctx, esc_subscription_t* s, esc_resolved_event_t* ev);
typedef struct st_event_appeared_callback {
    esc_event_appeared_t fn;
    void* ctx;
} esc_event_appeared_callback_t;

typedef void (*esc_subscription_droppped_t)(void* ctx, esc_subscription_t* subscription, const char* reason, error_t* error);
typedef struct st_subscription_dropped_callback {
    esc_subscription_droppped_t fn;
    void* ctx;
} esc_subscription_dropped_callback_t;

typedef enum {
    ESC_SUBSCRIBING,
    ESC_SUBSCRIBED,
    ESC_DROPPED
} esc_subscription_state_t;

esc_subscription_t* esc_subscription_create(esc_connection_t* conn, uuid_t* correlation_id,
                                            esc_event_appeared_callback_t event_appeared,
                                            esc_subscription_dropped_callback_t subscription_dropped);
void esc_subscription_handle_tcp_package(esc_subscription_t* subscription, tcp_package_t* pkg);
bool_t esc_find_subscription_by_correlation_id(void* item, void* arg);
esc_subscription_state_t esc_subscription_state(esc_subscription_t* subscription);
void esc_subscription_stop(esc_subscription_t* subscription);

#endif //EVENSTORE_CLIENT_C_SUBSCRIPTION_H
